<?php
namespace Folha\Entities;

class GpeAltesitufunc extends Base\Gpealtesitufunc
{
	// LISTA DE MÉTODOS UTILIZADOS EXCLUISIVAMENTE NA MIGRACAO ALINUTRI.
    public static function geraNovoCodigoMigracao($nrsitufuncm, $dtinisitufunc, $nrorg)
    {
        if (!$dtinisitufunc instanceof \DateTime) {
            $dtinisitufunc = \HCM\Util\DateUtil::getDataDeString(
                $dtinisitufunc, \HCM\Util\DateUtil::FORMATO_BRASILEIRO, true
            );
        }

    	$situacaoFunicional = self::findOneByNrsitufuncmAndDtinisitufuncAndNrorg($nrsitufuncm, $dtinisitufunc, $nrorg);
    	if ($situacaoFunicional instanceof \Folha\Entities\GpeAltesitufunc) {
    		$nrsitufuncm = $situacaoFunicional->getNrsitufuncm();
    	} else {
    		$nrsitufuncm = \Geral\Util\NovoCodigo::geraNovoCodigoMigracao('GPE_ALTESITUFUNC', 'NRALTESITUFUNC', $nrorg);
    	}

    	return $nrsitufuncm;
    }

    /**
     * Retorna a última situacao funcional do vínculo
     *
     * @param $nrvinculom
     * @param $nrorg
     * @return bool
     *
     * leonardocarvalho - 22/08/2014
     */
    public static function retornaUltimaSitucaoFuncional($nrvinculom, $nrorg) {

        $params = array($nrorg, $nrvinculom, $nrorg, $nrvinculom, \FPA::getUltimoDiaMes());

        $result = self::getObjectByWhere("NRORG         = ?
  AND NRVINCULOM    = ?
  AND DTINISITUFUNC = (SELECT MAX(DTINISITUFUNC)
                         FROM GPE_ALTESITUFUNC B
                       WHERE B.NRORG       = ?
                         AND B.NRVINCULOM  = ?
                         AND DTINISITUFUNC <= TO_DATE(?, 'DD/MM/YYYY'))", $params);

        return $result;
    }
    public static function retornaUltimaSitufuncGeral($nrvinculom, $nrorg) {

        $params = array($nrorg, $nrvinculom, $nrorg, $nrvinculom);

        $result = self::getObjectByWhere("NRORG         = ?
  AND NRVINCULOM    = ?
  AND DTINISITUFUNC = (SELECT MAX(DTINISITUFUNC)
                         FROM GPE_ALTESITUFUNC B
                       WHERE B.NRORG       = ?
                         AND B.NRVINCULOM  = ?)", $params);

        return $result;
    }


}