IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'VERIFICA_CARD_PADRAO'
             AND TYPE   = 'P'
             AND U.UID  = O.UID
             AND U.NAME = USER)
   DROP PROCEDURE VERIFICA_CARD_PADRAO
GO

/* CRIAO */
CREATE PROCEDURE VERIFICA_CARD_PADRAO(
   @P_CDFILIAL   VARCHAR(04),
   @P_DTMESCARD  DATETIME   ,
   @P_NRLISTA    VARCHAR(10))
AS
   DECLARE @V_IDUTCARDPADR VARCHAR(01);
   DECLARE @V_IDCENTRAL VARCHAR(01);
   DECLARE @VC_SERVICO_CDSERVFILI VARCHAR(05);
   DECLARE @VC_FILIAL_AGREG_CDFILIAL VARCHAR(04);
   DECLARE @VC_PRATO_NEXIST_CDFILAUXPRAT VARCHAR(4);
   DECLARE @VC_PRATO_NEXIST_CDPRATO VARCHAR(10);

BEGIN
   SELECT @V_IDUTCARDPADR = MAX(IDUTCARDPADR)
   FROM PARAMGERAL;

   IF (@V_IDUTCARDPADR = 'S') BEGIN

      SELECT @V_IDCENTRAL = MAX(IDFILCENTPME)
      FROM FILIAL
      WHERE CDFILIAL = @P_CDFILIAL;

      IF (@V_IDCENTRAL <> 'S') BEGIN
         RETURN;
      END;

      DELETE FROM LOGCARDPADRAO
      WHERE CDFILIAL = @P_CDFILIAL
        AND DTMESCARD = @P_DTMESCARD;

      DECLARE C_SERVICO CURSOR FOR
         SELECT CDLISTA AS CDSERVFILI
         FROM   LISTA
         WHERE (NRLISTA = @P_NRLISTA);
      OPEN C_SERVICO;
      FETCH NEXT FROM C_SERVICO INTO @VC_SERVICO_CDSERVFILI;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         /* GRAVAR A CONFIGURACAO DO SERVICO DAS FILIAIS AGREGADAS */
         DECLARE C_FILIAL_AGREG CURSOR FOR
            SELECT DISTINCT F.CDFILIAL
            FROM FILIAL F, SERVICO S, CONFCARD C
            WHERE (F.CDFILCENTPME = @P_CDFILIAL           ) AND
                  (S.CDFILIAL     = F.CDFILIAL            ) AND
                  (S.CDSERVFILI   = @VC_SERVICO_CDSERVFILI) AND
                  (C.CDFILIAL     = S.CDFILIAL            ) AND
                  (C.CDSERVFILI   = S.CDSERVFILI          );
         OPEN C_FILIAL_AGREG;
         FETCH NEXT FROM C_FILIAL_AGREG INTO @VC_FILIAL_AGREG_CDFILIAL;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            INSERT INTO LOGCARDPADRAO(IDLOGCARDPAD, NRSEQLOGCARD, CDFILIAL,
                                      CDSERVFILI, DTMESCARD, CDFILIAGRE,
                                      DTCARDAPIO, CDPRATO, CDFILAUXPRAT,
                                      CDTIPOPRAT)
            (SELECT '1', row_number() over(order by ca.cdfilial), CA.CDFILIAL,
                    CA.CDSERVFILI, CA.DTMESCARD, @VC_FILIAL_AGREG_CDFILIAL,
                    CA.DTCARDAPIO, CP.CDPRATO, CP.CDFILAUXPRAT,
                    CP.CDTIPOPRAT
             FROM CARDADIA CA, COMPCARD CP, PRATO PR
             WHERE CA.CDFILIAL = @P_CDFILIAL
               AND CA.CDSERVFILI = @VC_SERVICO_CDSERVFILI
               AND CA.DTMESCARD = @P_DTMESCARD
               AND CP.CDFILIAL = CA.CDFILIAL
               AND CP.NRCARDAPIO = CA.NRCARDAPIO
               AND CP.CDFILAUXPRAT = @P_CDFILIAL
               AND PR.CDPRATO = CP.CDPRATO
               AND PR.CDFILAUXPRAT = CP.CDFILAUXPRAT
               AND NOT EXISTS(SELECT PRATO.CDPRATO
                              FROM PRATO
                              WHERE PRATO.CDFILAUXPRAT = @VC_FILIAL_AGREG_CDFILIAL
                                AND PRATO.CDPRATO = CP.CDPRATO
                                AND UPPER(PRATO.NMPRATO) = UPPER(PR.NMPRATO)
                             )
            );

            DECLARE C_PRATO_NEXIST CURSOR FOR
               SELECT DISTINCT CP.CDFILAUXPRAT, CP.CDPRATO
               FROM CARDADIA CA, COMPCARD CP, PRATO PR
               WHERE CA.CDFILIAL = @P_CDFILIAL
                AND CA.CDSERVFILI = @VC_SERVICO_CDSERVFILI
                AND CA.DTMESCARD = @P_DTMESCARD
                AND CP.CDFILIAL = CA.CDFILIAL
                AND CP.NRCARDAPIO = CA.NRCARDAPIO
                AND CP.CDFILAUXPRAT = @P_CDFILIAL
                AND NOT EXISTS(SELECT PRATO.CDPRATO
                               FROM PRATO
                               WHERE PRATO.CDFILAUXPRAT = @VC_FILIAL_AGREG_CDFILIAL
                                 AND PRATO.CDPRATO = CP.CDPRATO)
                AND PR.CDPRATO = CP.CDPRATO
                AND PR.CDFILAUXPRAT = CP.CDFILAUXPRAT
            OPEN C_PRATO_NEXIST;
            FETCH NEXT FROM C_PRATO_NEXIST INTO @VC_PRATO_NEXIST_CDFILAUXPRAT, @VC_PRATO_NEXIST_CDPRATO;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               UPDATE LOGCARDPADRAO
               SET IDLOGCARDPAD = '0'
               WHERE CDFILIAL = @P_CDFILIAL
                 AND CDSERVFILI = @VC_SERVICO_CDSERVFILI
                 AND DTMESCARD = @P_DTMESCARD
                 AND CDFILIAGRE = @VC_FILIAL_AGREG_CDFILIAL
                 AND CDPRATO = @VC_PRATO_NEXIST_CDPRATO
                 AND CDFILAUXPRAT = @VC_PRATO_NEXIST_CDFILAUXPRAT;

               FETCH NEXT FROM C_PRATO_NEXIST INTO @VC_PRATO_NEXIST_CDFILAUXPRAT, @VC_PRATO_NEXIST_CDPRATO;
            END;
            CLOSE C_PRATO_NEXIST;
            DEALLOCATE C_PRATO_NEXIST;

            FETCH NEXT FROM C_FILIAL_AGREG INTO @VC_FILIAL_AGREG_CDFILIAL;
         END;
         CLOSE C_FILIAL_AGREG;
         DEALLOCATE C_FILIAL_AGREG;

         FETCH NEXT FROM C_SERVICO INTO @VC_SERVICO_CDSERVFILI;
      END;
      CLOSE C_SERVICO;
      DEALLOCATE C_SERVICO;
   END;

   DELETE FROM LISTA
   WHERE NRLISTA = @P_NRLISTA;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'VERIFICA_CARD_PADRAO','5.30.000';
GO

